/// <reference types="react" />
import { AddressConfirmOptions, AddressConfirmShowResult } from '@mapbox/search-js-web';
interface UseConfirmAddressObject {
    formRef: React.RefObject<HTMLFormElement>;
    showConfirm: (options?: Partial<AddressConfirmOptions>) => Promise<AddressConfirmShowResult>;
}
/**
 * A React hook that returns a form ref and a function to show the address confirmation modal
 *
 * @param {AddressConfirmOptions} optionsArg
 * @see {@link confirmAddress}
 */
export declare function useConfirmAddress(optionsArg?: AddressConfirmOptions): UseConfirmAddressObject;
export {};
